// Last change July 8th 1999

#include "greedysplit.h"


void main(int argc, char *argv[])
{

    long        curtime, start_time, start_loc, end_time;
    long	oid;
    long	t1, t2, t3;
    float	x1, x2, y1, y2;
    int         oper;
    float       a11, b11, a12, b12, a21, b21, a22, b22;
    int 	NofFinObj;
    int 	InNumObj;
    float	mdlx1, mdlx2, mdly1, mdly2;
    float	big_x1, big_x2, big_y1, big_y2;
    float	first_x1, first_x2, first_y1, first_y2;
    float	sec_x1, sec_x2, sec_y1, sec_y2;
    int		curnumobj;
    MovObject	temp_obj;
    long	NumInserted;
    long	maxtime;

    priority_queue<MovObject> PQ;



    if (argc != 4) {
         cout << " Usage: " << argv[0] << " input_file output_file #of_final_objects" << "\n";
         exit(-1);
    }

    ifstream from(argv[1]);
    if (!from) {
	cout << " Unable to open the file: " << argv[1] << "\n";
	exit(-1);
    }

    ofstream to(argv[2]);
    if (!to) {
	cout << " Unable to open the file: " << argv[2] << "\n";
        exit(-1);
    }

    NofFinObj = atoi(argv[3]);

    MovObject *STOBJ;

    STOBJ = new MovObject[NOB];

    for (int i=0; i < NOB; i++) {
	STOBJ[i].tt[0] = -1;
	STOBJ[i].tt[1] = -1;
    }
	
    curtime = 0;

    // "%d %d %d %f %f %f %f %d %d\n", &curtime, &oper, &oid, 
    // &x1, &x2, &y1, &y2, &start_time, &end_time);

   from >> curtime;
   from >> oper;
   from >> oid;
   from >> x1 >> x2 >> y1 >> y2;
   from >> start_time;
   from >> end_time;



    InNumObj = 0;
    NumInserted = 0;
    

    while (curtime != -1) {
	if (oper == INSERT) {
	  
	  if (STOBJ[oid].tt[0] == -1) {
		STOBJ[oid].fxy[0] = x1;
		STOBJ[oid].fxy[1] = x2;
		STOBJ[oid].fxy[2] = y1;
		STOBJ[oid].fxy[3] = y2;
		STOBJ[oid].oid = oid;

		STOBJ[oid].tt[0] = start_time;
		NumInserted++;

	  } else {
		cout << " Two objects with the same id: ";
		cout << oid <<" " << start_time << "\n";
		exit(-1);
	  }
	}

	if (oper == DELETE) {
	  InNumObj++;
	  if (STOBJ[oid].tt[1] == -1) {
		
		temp_obj.fxy[0] = STOBJ[oid].fxy[0];	
		temp_obj.fxy[1] = STOBJ[oid].fxy[1];	
		temp_obj.fxy[2] = STOBJ[oid].fxy[2];	
		temp_obj.fxy[3] = STOBJ[oid].fxy[3];	

		temp_obj.exy[0] = x1;
		temp_obj.exy[1] = x2;
		temp_obj.exy[2] = y1;
		temp_obj.exy[3] = y2;

		temp_obj.oid = oid;

		temp_obj.tt[0] = STOBJ[oid].tt[0];
		temp_obj.tt[1] = end_time;

		if (end_time-start_time > 2) {
			temp_obj.splitpoint = start_time + (end_time-start_time)/2;
			t1 = start_time;
			t2 = end_time;
                        t3 = temp_obj.splitpoint;

			// now compute the gain 

			// first compute the middle rectangle 
			// computing intermediate points for each corner 

                  	// sx1->x1 
                  	a11 = (temp_obj.exy[0]-temp_obj.fxy[0])/(t2-t1);
                  	b11 = temp_obj.fxy[0]-a11*t1;

                  	// sy1->y1 
                  	a12 = (temp_obj.exy[2]-temp_obj.fxy[2])/(t2-t1);
                  	b12 = temp_obj.fxy[2]-a12*t1;

                  	// sx2->x2
                  	a21 = (temp_obj.exy[1]-temp_obj.fxy[1])/(t2-t1);
                  	b21 = temp_obj.fxy[1]-a21*t1;

                  	// sy2->y2 
                  	a22 = (temp_obj.exy[3]-temp_obj.fxy[3])/(t2-t1);
                  	b22 = temp_obj.fxy[3]-a22*t1;

			mdlx1 = a11*temp_obj.splitpoint + b11;
			mdly1 = a12*temp_obj.splitpoint + b12;
			mdlx2 = a21*temp_obj.splitpoint + b21;
			mdly2 = a22*temp_obj.splitpoint + b22;
			

			big_x1 = min(temp_obj.fxy[0], temp_obj.exy[0]);
			big_x2 = max(temp_obj.fxy[1], temp_obj.exy[1]);
			big_y1 = min(temp_obj.fxy[2], temp_obj.exy[2]);
			big_y2 = max(temp_obj.fxy[3], temp_obj.exy[3]);

			
			first_x1 = min(temp_obj.fxy[0], mdlx1);
			first_x2 = max(temp_obj.fxy[1], mdlx2);
			first_y1 = min(temp_obj.fxy[2], mdly1);
			first_y2 = max(temp_obj.fxy[3], mdly2);

			
			sec_x1 = min(mdlx1, temp_obj.exy[0]);
			sec_x2 = max(mdlx2, temp_obj.exy[1]);
			sec_y1 = min(mdly1, temp_obj.exy[2]);
			sec_y2 = max(mdly2, temp_obj.exy[3]);

			
			temp_obj.gain = ((big_x2-big_x1)*(big_y2-big_y1)*(t2-t1)) -
					((first_x2-first_x1)*(first_y2-first_y1)*(t3-t1)) -
					((sec_x2-sec_x1)*(sec_y2-sec_y1)*(t2-t3));

			// cout << "  " << temp_obj.gain << "\n";

		
			// insert the object into the priority queue

			PQ.push(temp_obj);

		} else {
			temp_obj.splitpoint = 0;
			temp_obj.gain = 0.0;

			PQ.push(temp_obj);
		}
		
		STOBJ[oid].tt[0] = -1;
		STOBJ[oid].tt[1] = -1;

	  } else {
		cout << " Two objects with the same id: ";
		cout << oid <<" " << start_time << "\n";
                exit(-1);
          }
        }
   
	maxtime = curtime;

        from >> curtime;
   	from >> oper;
   	from >> oid;
   	from >> x1 >> x2 >> y1 >> y2;
   	from >> start_time;
   	from >> end_time;

   }

   for (int i=0; i < NOB; i++) {
	if ((STOBJ[i].tt[1] == -1) && (STOBJ[i].tt[0] != -1)) {
		STOBJ[i].tt[1] = maxtime+10;

		temp_obj.fxy[0] = STOBJ[i].fxy[0];
                temp_obj.fxy[1] = STOBJ[i].fxy[1];
                temp_obj.fxy[2] = STOBJ[i].fxy[2];
                temp_obj.fxy[3] = STOBJ[i].fxy[3];

                temp_obj.exy[0] = STOBJ[i].fxy[0];
                temp_obj.exy[1] = STOBJ[i].fxy[1];
                temp_obj.exy[2] = STOBJ[i].fxy[2];
                temp_obj.exy[3] = STOBJ[i].fxy[3];

		temp_obj.tt[0] = STOBJ[i].tt[0];
		temp_obj.tt[1] = STOBJ[i].tt[1];

		temp_obj.gain = 0.0;
		temp_obj.oid  = STOBJ[i].oid;

		temp_obj.splitpoint = temp_obj.tt[0] + (temp_obj.tt[1]-temp_obj.tt[0])/2;

		PQ.push(temp_obj);
		InNumObj++;
	}
   }
		
	
   delete [] STOBJ;

   if (InNumObj >= NofFinObj) {
	cout << " Number of initial objects more than the final objects!!!\n" ;
   }

   curnumobj = InNumObj;
   while ( curnumobj < NofFinObj) {

	MovObject topobject = PQ.top();

	if (topobject.splitpoint == 0) {
		break;
	}

	PQ.pop();

	// create two new objects p1 and p2 
	t1 = topobject.tt[0];
        t2 = topobject.tt[1];
	
	// first compute the middle rectangle
        // computing intermediate points for each corner

        // sx1->x1 
        a11 = (topobject.exy[0]-topobject.fxy[0])/(t2-t1);
        b11 = topobject.fxy[0]-a11*t1;

        // sy1->y1
        a12 = (topobject.exy[2]-topobject.fxy[2])/(t2-t1);
        b12 = topobject.fxy[2]-a12*t1;

        // sx2->x2 
        a21 = (topobject.exy[1]-topobject.fxy[1])/(t2-t1);
        b21 = topobject.fxy[1]-a21*t1;

        // sy2->y2
        a22 = (topobject.exy[3]-topobject.fxy[3])/(t2-t1);
        b22 = topobject.fxy[3]-a22*t1;


	mdlx1 = a11*topobject.splitpoint + b11;
        mdly1 = a12*topobject.splitpoint + b12;
        mdlx2 = a21*topobject.splitpoint + b21;
        mdly2 = a22*topobject.splitpoint + b22;

	MovObject SecObject;

	SecObject.exy[0] = topobject.exy[0];
	SecObject.exy[1] = topobject.exy[1];
	SecObject.exy[2] = topobject.exy[2];
	SecObject.exy[3] = topobject.exy[3];

	topobject.exy[0] = mdlx1;
	topobject.exy[1] = mdlx2;
	topobject.exy[2] = mdly1;
	topobject.exy[3] = mdly2;

	SecObject.tt[1] = topobject.tt[1];

	topobject.tt[1] = topobject.splitpoint;

	SecObject.fxy[0] = mdlx1;
	SecObject.fxy[1] = mdlx2;
	SecObject.fxy[2] = mdly1;
	SecObject.fxy[3] = mdly2;

	SecObject.tt[0] = topobject.splitpoint;
	SecObject.oid = topobject.oid;

	// now compute splitpoint and gain for each new object

	if (topobject.tt[1]-topobject.tt[0] > 2) {
	
		t1 = topobject.tt[0];
		t2 = topobject.tt[1];

		topobject.splitpoint = t1 + (t2-t1)/2;
                t3 = topobject.splitpoint;

		a11 = (topobject.exy[0]-topobject.fxy[0])/(t2-t1);
                b11 = topobject.fxy[0]-a11*t1;

		a12 = (topobject.exy[2]-topobject.fxy[2])/(t2-t1);
                b12 = topobject.fxy[2]-a12*t1;

                // sx2->x2
                a21 = (topobject.exy[1]-topobject.fxy[1])/(t2-t1);
                b21 = topobject.fxy[1]-a21*t1;

                // sy2->y2
                a22 = (topobject.exy[3]-topobject.fxy[3])/(t2-t1);
                b22 = topobject.fxy[3]-a22*t1;

		mdlx1 = a11*topobject.splitpoint + b11;
                mdly1 = a12*topobject.splitpoint + b12;
                mdlx2 = a21*topobject.splitpoint + b21;
                mdly2 = a22*topobject.splitpoint + b22;

		big_x1 = min(topobject.fxy[0], topobject.exy[0]);
                big_x2 = max(topobject.fxy[1], topobject.exy[1]);
                big_y1 = min(topobject.fxy[2], topobject.exy[2]);
                big_y2 = max(topobject.fxy[3], topobject.exy[3]);


                first_x1 = min(topobject.fxy[0], mdlx1);
                first_x2 = max(topobject.fxy[1], mdlx2);
                first_y1 = min(topobject.fxy[2], mdly1);
                first_y2 = max(topobject.fxy[3], mdly2);


                sec_x1 = min(mdlx1, topobject.exy[0]);
                sec_x2 = max(mdlx2, topobject.exy[1]);
                sec_y1 = min(mdly1, topobject.exy[2]);
                sec_y2 = max(mdly2, topobject.exy[3]);

		topobject.gain = ((big_x2-big_x1)*(big_y2-big_y1)*(t2-t1)) -
                                 ((first_x2-first_x1)*(first_y2-first_y1)*(t3-t1)) -
                                 ((sec_x2-sec_x1)*(sec_y2-sec_y1)*(t2-t3));

		// cout << "  " << topobject.gain << "\n";

		PQ.push(topobject);
		
	 } else {

		topobject.gain = 0.0;
		topobject.splitpoint = 0;
	
		PQ.push(topobject);
	}

	if (SecObject.tt[1]-SecObject.tt[0] > 2) {
	
		t1 = SecObject.tt[0];
		t2 = SecObject.tt[1];

		SecObject.splitpoint = t1 + (t2-t1)/2;
                t3 = SecObject.splitpoint;

		a11 = (SecObject.exy[0]-SecObject.fxy[0])/(t2-t1);
                b11 = SecObject.fxy[0]-a11*t1;

		a12 = (SecObject.exy[2]-SecObject.fxy[2])/(t2-t1);
                b12 = SecObject.fxy[2]-a12*t1;

                // sx2->x2
                a21 = (SecObject.exy[1]-SecObject.fxy[1])/(t2-t1);
                b21 = SecObject.fxy[1]-a21*t1;

                // sy2->y2
                a22 = (SecObject.exy[3]-SecObject.fxy[3])/(t2-t1);
                b22 = SecObject.fxy[3]-a22*t1;

		mdlx1 = a11*SecObject.splitpoint + b11;
                mdly1 = a12*SecObject.splitpoint + b12;
                mdlx2 = a21*SecObject.splitpoint + b21;
                mdly2 = a22*SecObject.splitpoint + b22;

		big_x1 = min(SecObject.fxy[0], SecObject.exy[0]);
                big_x2 = max(SecObject.fxy[1], SecObject.exy[1]);
                big_y1 = min(SecObject.fxy[2], SecObject.exy[2]);
                big_y2 = max(SecObject.fxy[3], SecObject.exy[3]);


                first_x1 = min(SecObject.fxy[0], mdlx1);
                first_x2 = max(SecObject.fxy[1], mdlx2);
                first_y1 = min(SecObject.fxy[2], mdly1);
                first_y2 = max(SecObject.fxy[3], mdly2);


                sec_x1 = min(mdlx1, SecObject.exy[0]);
                sec_x2 = max(mdlx2, SecObject.exy[1]);
                sec_y1 = min(mdly1, SecObject.exy[2]);
                sec_y2 = max(mdly2, SecObject.exy[3]);

		SecObject.gain = ((big_x2-big_x1)*(big_y2-big_y1)*(t3-t1)) -
                                 ((first_x2-first_x1)*(first_y2-first_y1)*(t3-t1)) -
                                 ((sec_x2-sec_x1)*(sec_y2-sec_y1)*(t2-t3));

		 // cout << "  " << SecObject.gain << "\n";

		PQ.push(SecObject);
		
	 } else {

		SecObject.gain = 0.0;
		SecObject.splitpoint = 0;
	
		PQ.push(SecObject);
	}
		
	curnumobj++;
   }	


   while (!PQ.empty()) {

	MovObject outobj = PQ.top();

	PQ.pop();

	to << outobj.tt[0] << " " << INSERT << " " << outobj.oid << " " ;
	to << outobj.get_lowx() << " " << outobj.get_highx() << " " ;
	to << outobj.get_lowy() << " " << outobj.get_highy() << " ";
	to << outobj.tt[0] << " " << NOW << "\n";

	to << outobj.tt[1] << " " << DELETE << " " << outobj.oid << " "
             << outobj.get_lowx() << " " << outobj.get_highx() << " "
             << outobj.get_lowy() << " " << outobj.get_highy() << " "
             << outobj.tt[0] << " " << outobj.tt[1] << "\n";

   }
   

}
