#if !defined(__GREEDYSPLIT_H_)
#define __GREEDYSPLIT_H_

#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>
#include <stack.h>
#include <vector.h>

#define  INSERT         2
#define  DELETE         1
#define  QUERY          3

#define  STDMODE        0644

#define  NOW            1000000

#define max( a, b)      ((a) > (b) ? (a) : (b))
#define min( a, b)      ((a) < (b) ? (a) : (b))



#define  NOB	1000000

class MovObject{
    public:
	float	fxy[4];
	float	exy[4];
	long  	tt[2];
	long	splitpoint;
	long	oid;
	float	gain;

	float	get_lowx() {  return(min(fxy[0], exy[0])); }
	float	get_highx() {  return(max(fxy[1], exy[1])); }
	float	get_lowy() {  return(min(fxy[2], exy[2])); }
	float	get_highy() {  return(max(fxy[3], exy[3])); }

	MovObject() ;
	MovObject( const MovObject &other);
	~MovObject() {} ;
		
	void operator=(const MovObject &other);
				
	bool operator<(const MovObject &y) const
        {
                return(gain < y.gain);
        }

        bool operator==(const MovObject &y) const
        {
                return(gain == y.gain);
        }

        bool operator>(const MovObject &y) const
        {
                return(gain > y.gain);
        }


};

MovObject::MovObject()
{
	for (int i=0; i < 4; i++) {
		fxy[i] = -1.0;
		exy[i] = -1.0;
	}

	tt[0] = -1;
	tt[1] = -1;
	oid = -1;
	splitpoint = -1;
	gain = -1.0;

}

MovObject::MovObject( const MovObject &other)
{

	for (int i=0; i < 4; i++) {
		fxy[i] = other.fxy[i];
		exy[i] = other.exy[i];
	}

	tt[0] = other.tt[0];
	tt[1] = other.tt[1];

	splitpoint = other.splitpoint;
	gain = other.gain;
	oid = other.oid;
}


void MovObject::operator=(const MovObject &other)
{

	for (int i=0; i < 4; i++) {
		fxy[i] = other.fxy[i];
		exy[i] = other.exy[i];
	}

	tt[0] = other.tt[0];
	tt[1] = other.tt[1];

	splitpoint = other.splitpoint;
	gain = other.gain;
	oid = other.oid;
}

#endif // __GREEDYSPLIT_H_
