// Efficient Indexing of Spatiotemporal Objects
// Copyright (C) 2003 Marios Hadjieleftheriou
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Contact information:
//  Mailing address:
//    Marios Hadjieleftheriou
//    University of California, Riverside
//    Department of Computer Science
//    Surge Building, Room 310
//    Riverside, CA 92521
//
//  Email:
//    marioh@cs.ucr.edu

/*
	Converts boxes to Yufei's MVR-tree format.
*/

#include "global.h"

int main(int argc, char** argv)
{
	if (argc != 2)
	{
		cerr << "Usage: " << argv[0] << " box_file." << endl;
		return -1;
	}

	ifstream f(argv[1]);
	if (! f)
	{
		cerr << "Cannot open file " << argv[1] << "." << endl;
		return -1;
	}

	cout.precision(PRECISION);
	cout << fixed;

	char buf[1000];
	while (f.getline(buf, 1000))
	{
		istringstream ss(buf);
		int id, start, end;
		double x1, x2, y1, y2;

		ss >> id;
		if (! f.good()) break;

		ss >> x1 >> x2 >> y1 >> y2 >> start >> end;

		cout << id << " " << start << " " << x1 << " " << y1 << " "
			<< x2 << " " << y2 << " 1" << endl;
	}
}
